mobs:register_mob("mobs:goblin", {
	type = "monster",
	hp_min = 5,
	hp_max = 15,
	exp_min = 5,
	exp_max = 20,
	collisionbox = {-0.35,-1.0,-0.35, 0.35,0.0,0.35},
	visual = "mesh",
	mesh = "goblins_goblin.b3d",
	textures = {"goblins_goblin_coal1.png"},
	visual_size = {x=1, y=1},
	makes_footstep_sound = false,
	view_range = 8,
	walk_velocity = 2,
	run_velocity = 3,
	damage = 1.5,
	drops = { },
	armor = 150,
	drawtype = "front",
	water_damage = 1,
	lava_damage = 5,
	light_damage = 0,
	on_rightclick = nil,
	attack_type = "dogfight",
	animation = {
		speed_normal = 30,
		speed_run = 30,
		stand_start = 0,
		stand_end = 79,
		walk_start = 168,
		walk_end = 187,
		run_start = 168,
		run_end = 187,
		punch_start = 200,
		punch_end = 219,
	},
	jump = true,
	sounds = {
		death = "mobs_goblin_death",
		random = "mobs_goblin_ambience",
		attack = "default_punch2",
		war_cry = "mobs_goblin_warcry",
	},
	step=0.5,
	blood_amount = 15,
	blood_offset = 0.25,
	activity_level=2,
	lifetimer = false,
})

mobs:register_mob("mobs:goblin_king", {
	type = "monster",
	hp_min = 8,
	hp_max = 22,
	exp_min = 10,
	exp_max = 35,
		collisionbox = {-0.35,-1.0,-0.35, 0.35,0.0,0.35},
	visual = "mesh",
	mesh = "goblins_goblin.b3d",
	textures = {"goblins_goblin_king.png"},
	visual_size = {x=1, y=1},
	makes_footstep_sound = false,
	view_range = 12,
	walk_velocity = 2,
	run_velocity = 3.5,
	damage = 2,
	drops = { 
		{name = "mobs:goblin_king_crown",
		chance = 40,
		min = 1,
		max = 1,},
	},
	armor = 150,
	drawtype = "front",
	water_damage = 1,
	lava_damage = 5,
	light_damage = 0,
	on_rightclick = nil,
	attack_type = "dogfight",
	animation = {
		speed_normal = 30,
		speed_run = 30,
		stand_start = 0,
		stand_end = 79,
		walk_start = 168,
		walk_end = 187,
		run_start = 168,
		run_end = 187,
		punch_start = 200,
		punch_end = 219,
	},
	jump = true,
	sounds = {
		death = "mobs_goblin_death",
		random = "mobs_goblin_king_ambience",
		attack = "default_punch2",
		war_cry = "mobs_goblin_warcry",
	},
	step=0.5,
	blood_amount = 15,
	blood_offset = 0.25,
	activity_level=2,
	lifetimer = false,
})

minetest.register_tool("mobs:goblin_king_crown", {
	description = "Goblin King's Crown",
	inventory_image = "mobs_inv_goblin_king_crown.png",
	groups = {armor_head=10, armor_heal=24, armor_use=50},
	wear = 0,
})
